{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Operationen für verkettete Listen implementieren (Teil 2)\n",
    "\n",
    "In diesem zweiten Teil der Programmieraufgabe findest du\n",
    "\n",
    "```{margin}\n",
    "Wie immer gilt: Betrüge dich nicht selbst, indem zu früh in die Musterlösungen schaust!\n",
    "```\n",
    "\n",
    "- weitere Methoden, die du implementieren sollst, und \n",
    "- Musterlösungen für die Methoden aus dem ersten Teil. (Manche davon kannst du vielleicht in abgewandelter Form für die neuen Aufgaben nutzen 😉)\n",
    "\n",
    "\n",
    "In diesem Notebook wirst du weitere Operationen der Klasse `VerketteteListe` implementieren, \n",
    "s. {numref}`fig_kd_verkettete_liste`. *Automatische Tests* werden dir dabei helfen, deine Implementierungen zu überprüfen. Diese \n",
    "Tests werden weiter unten definiert. Wie genau sie arbeiten ist für dich nicht wichtig; du\n",
    "musst nur sicherstellen, dass du die Operationen der Klasse `VerketteteListe` so implementierst,\n",
    "dass die Tests erfolgreich durchgeführt werden.\n",
    "\n",
    "**Hinweis:** \n",
    "- Lade dieses Notebook von der Webseite herunter und bearbeite es auf deinem Computer. \n",
    "- Führe mit **Run All** das gesamte Notebook am Anfang einmal aus. Dadurch werden die Tests definiert, mit denen du deinen Fortschritt beim Bearbeiten der Übungen überprüfen kannst.\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 1,
   "metadata": {
    "tags": [
     "hide-cell"
    ]
   },
   "outputs": [],
   "source": [
    "# DIESE TESTS BITTE NICHT VERÄNDERN\n",
    "\n",
    "class TestsVerketteteListe:\n",
    "    def __init__(self, KlasseVerketteteListe):\n",
    "        self.ZuTestendeKlasse = KlasseVerketteteListe\n",
    "        tests = [methode for methode in dir(self) if methode.startswith('teste') and callable(getattr(self, methode))]\n",
    "        self.anzahl_tests = len(tests)\n",
    "        self.bestandene_tests = 0\n",
    "\n",
    "    def erfolgreicher_test(self, methodenname, anzahl_tests=None):\n",
    "        if anzahl_tests is not None:\n",
    "            self.anzahl_tests = anzahl_tests\n",
    "        self.bestandene_tests += 1\n",
    "        print(f\"  {methodenname} war erfolgreich. Aktuelle Punktzahl: {self.bestandene_tests}/{self.anzahl_tests}\")\n",
    "\n",
    "    def fuehre_tests_aus(self, reihenfolge: list[str]):\n",
    "        anzahl_tests = len(reihenfolge)\n",
    "        print(\"Mögen die Tests beginnen!\")\n",
    "        for test_name in reihenfolge:\n",
    "            test_name = \"teste_\" + test_name\n",
    "            if not hasattr(self, test_name):\n",
    "                print(f\"Test {test_name} existiert nicht.\")\n",
    "                continue\n",
    "            test_methode = getattr(self, test_name)\n",
    "            print(f\"Starte Test: {test_name}...\")\n",
    "            # Fange Fehler ab und gib die Fehlermeldung aus\n",
    "            try:\n",
    "                test_methode()\n",
    "            except AssertionError as e:\n",
    "                print(f\"!!! {test_name} fehlgeschlagen: {e}\")\n",
    "                break\n",
    "            self.erfolgreicher_test(test_name, anzahl_tests)\n",
    "        if self.bestandene_tests == self.anzahl_tests:\n",
    "            print(\"\\nHerzlichen Glückwunsch! Alle Tests erfolgreich.\")\n",
    "        else:\n",
    "            print(\"\\nLeider waren noch nicht alle Tests erfolgreich. Probiere es noch einmal!\")\n",
    "\n",
    "    def beispiel_liste(self):\n",
    "        # print(\"Liste vorbereiten\")\n",
    "        test_liste = self.ZuTestendeKlasse()\n",
    "        test_liste.einfuegen_vorne(\"Anna\")   # Diese Methode existiert schon\n",
    "        test_liste.einfuegen_vorne(\"Bibi\")\n",
    "        test_liste.einfuegen_vorne(\"Coco\")\n",
    "        test_liste.einfuegen_vorne(\"Dina\")\n",
    "        # print(\"Die Liste sieht am Anfang so aus:\", test_liste)\n",
    "        return test_liste\n",
    "    \n",
    "    def teste_ist_leer(self):\n",
    "        leere_liste = self.ZuTestendeKlasse()\n",
    "        assert leere_liste.ist_leer() == True, \"Ein leere verkettete Liste wurde nicht als leer erkannt. Tipp: Die Methode ist_leer() sollte True zurückgeben, wenn der Kopf der Liste None ist.\"    \n",
    "        liste = self.beispiel_liste()\n",
    "        assert liste.ist_leer() == False, \"Für eine Liste, die Elemente enthält, hat die Methode ist_leer() False zurückgegeben.\"\n",
    "\n",
    "    def teste_anzahl_elemente(self):\n",
    "        leere_liste = self.ZuTestendeKlasse()\n",
    "        korrekt = 0\n",
    "        ergebnis = leere_liste.anzahl_elemente()\n",
    "        assert ergebnis == korrekt, f\"Die korrekte Anzahl der Elemente in einer leeren Liste ist 0, aber deine Methode gibt {ergebnis} zurück.\"    \n",
    "        liste = self.beispiel_liste()\n",
    "        korrekt = 4\n",
    "        ergebnis = liste.anzahl_elemente()\n",
    "        assert ergebnis == korrekt, f\"Test mit Liste '{liste}'\\nDie korrekte Anzahl der Elemente in der Liste ist {korrekt}, aber deine Methode gibt {ergebnis} zurück.\"\n",
    "\n",
    "    def teste_gib_inhalt(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        erwartet = \"Dina\"\n",
    "        erhalten = liste.gib_inhalt(0)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nDas erste Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "        erwartet = \"Coco\"\n",
    "        erhalten = liste.gib_inhalt(1)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nDas zweite Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "        erwartet = \"Anna\"\n",
    "        erhalten = liste.gib_inhalt(3)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nDas letzte Element sollte {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_ersetzen(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.ersetzen(0, \"Ella\")\n",
    "        erwartet = \"Ella -> Coco -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Ersetzen des ersten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.ersetzen(1, \"Fiona\")\n",
    "        erwartet = \"Ella -> Fiona -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Ersetzen des zweiten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.ersetzen(3, \"Greta\")\n",
    "        erwartet = \"Ella -> Fiona -> Bibi -> Greta\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Ersetzen des letzten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_einfuegen(self):\n",
    "        liste = self.beispiel_liste()  # Dina -> Coco -> Bibi -> Anna\n",
    "        liste.einfuegen(2, \"Cocobibi\")\n",
    "        erwartet = \"Dina -> Coco -> Cocobibi -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Einfügen an Position 2 sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.einfuegen(0, \"Ella\")\n",
    "        erwartet = \"Ella -> Dina -> Coco -> Cocobibi -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Einfügen an Position 0 sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.einfuegen(6, \"Greta\")\n",
    "        erwartet = \"Ella -> Dina -> Coco -> Cocobibi -> Bibi -> Anna -> Greta\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Einfügen an Position 6 sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_enthaelt(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        assert liste.enthaelt(\"Anna\") == True, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Anna', aber deine Methode gibt False zurück.\"\n",
    "        assert liste.enthaelt(\"Bibi\") == True, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Bibi', aber dfeine Methode gibt False zurück.\"\n",
    "        assert liste.enthaelt(\"Coco\") == True, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Coco', aber deine Mfethode gibt False zurück.\"\n",
    "        assert liste.enthaelt(\"Dina\") == True, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Dina', aber deine Methodef gibt False zurück.\"\n",
    "        assert liste.enthaelt(\"Ella\") == False, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Ella' nicht, aber deine Methodef gibt True zurück.\"\n",
    "        assert liste.enthaelt(\"Fiona\") == False, f\"Test mit Liste '{liste}'\\nDie Liste enthält das Element 'Fiona' nicht, aber deine Methode gibtf True zurück.\"\n",
    "\n",
    "    def teste_anhaengen(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.anhaengen(\"Ella\")\n",
    "        erwartet = \"Dina -> Coco -> Bibi -> Anna -> Ella\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Anhängen sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.anhaengen(\"Fiona\")\n",
    "        erwartet = \"Dina -> Coco -> Bibi -> Anna -> Ella -> Fiona\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Anhängen sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste = VerketteteListe()\n",
    "        liste.anhaengen(\"Anna\")\n",
    "        erwartet = \"Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Anhängen sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_entfernen(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.entfernen(3)\n",
    "        erwartet = \"Dina -> Coco -> Bibi\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Anna' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen(1)\n",
    "        erwartet = \"Dina -> Bibi\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Coco' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen(0)\n",
    "        erwartet = \"Bibi\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Dina' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen(0)\n",
    "        erwartet = \"\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Bibi' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_entfernen_vorne(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.entfernen_vorne()\n",
    "        erwartet = \"Coco -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen des ersten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen_vorne()\n",
    "        erwartet = \"Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen des ersten Elements sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "\n",
    "    def teste_entfernen_inhalt(self):\n",
    "        liste = self.beispiel_liste()\n",
    "        liste.entfernen_inhalt(\"Coco\")\n",
    "        erwartet = \"Dina -> Bibi -> Anna\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Coco' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen_inhalt(\"Anna\")\n",
    "        erwartet = \"Dina -> Bibi\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Anna' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n",
    "        liste.entfernen_inhalt(\"Dina\")\n",
    "        erwartet = \"Bibi\"\n",
    "        erhalten = str(liste)\n",
    "        assert erhalten == erwartet, f\"Test mit Liste '{liste}'\\nNach dem Entfernen von 'Dina' sollte die Liste {erwartet} sein, ist aber {erhalten}.\"\n"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [],
   "source": [
    "# Die Klasse Knoten werden wir in dieser Aufgabe benutzen, aber nicht verändern.\n",
    "# Es gilt weiterhin: Ein Knoten speichert einen Inhalt und eine Referenz auf den nächsten Knoten.\n",
    "\n",
    "from __future__ import annotations   # brauchen wir, weil wir in der Klasse Knoten den Typ Knoten verwenden\n",
    "from typing import Any\n",
    "\n",
    "class Knoten:\n",
    "    def __init__(self, inhalt):\n",
    "        \"\"\" Konstruktor für die Klasse Knoten: speichert den Inhalt und legt\n",
    "        eine Referenz auf den nächsten Knoten an. \"\"\"\n",
    "        self.inhalt: Any = inhalt   # Any = inhalt kann beliebiger Datentyp sein\n",
    "        self.naechster: Knoten|None = None    # Typ-Annotation: naechster ist ein Knoten oder None\n",
    "\n",
    "    def __str__(self):\n",
    "        return str(self.inhalt)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Mögen die Tests beginnen!\n",
      "Starte Test: teste_enthaelt...\n",
      "!!! teste_enthaelt fehlgeschlagen: Test mit Liste 'Dina -> Coco -> Bibi -> Anna'\n",
      "Die Liste enthält das Element 'Anna', aber deine Methode gibt False zurück.\n",
      "\n",
      "Leider waren noch nicht alle Tests erfolgreich. Probiere es noch einmal!\n"
     ]
    }
   ],
   "source": [
    "class VerketteteListe:\n",
    "    def __init__(self):\n",
    "        self.erster: Knoten|None = None   # Der erste Knoten in der Liste (Listenkopf)    \n",
    "\n",
    "    def __str__(self) -> str:\n",
    "        \"\"\" Gibt die Liste als Zeichenkette, getrennt durch Pfeile, zurück. \"\"\"\n",
    "        inhalte = []\n",
    "        knoten = self.erster\n",
    "        while knoten is not None:\n",
    "            inhalte.append(knoten.inhalt)\n",
    "            knoten = knoten.naechster\n",
    "        return \" -> \".join(inhalte)\n",
    "\n",
    "    def einfuegen_vorne(self, pInhalt):\n",
    "        \"\"\"Fügt einen neuen Knoten mit pInhalt am Anfang der Liste ein.\"\"\"\n",
    "        neu = Knoten(pInhalt)   # \"Verpacke\" den Inhalt in einen Knoten\n",
    "        neu.naechster = self.erster  # Nachfolger des neuen Knotens ist der bisherige Listenkopf\n",
    "        self.erster = neu  # Der neue Knoten ist ab jetzt der Listenkopf\n",
    "\n",
    "   # AUFGABE: Implementiere die folgenden Methoden für die Klasse VerketteteListe:\n",
    "    \n",
    "    def ist_leer(self) -> bool:\n",
    "        \"\"\"gibt True zurück, wenn die Liste leer ist, sonst False\"\"\"\n",
    "        if self.erster is None:\n",
    "            return True\n",
    "        else:\n",
    "            return False\n",
    "\n",
    "    def anzahl_elemente(self) -> int:\n",
    "        \"\"\"gibt die Anzahl der Elemente in der Liste zurück\"\"\"\n",
    "        anzahl = 0\n",
    "        knoten = self.erster\n",
    "        while knoten is not None:\n",
    "            anzahl += 1\n",
    "            knoten = knoten.naechster\n",
    "        return anzahl\n",
    "    \n",
    "    def gib_inhalt(self, index: int) -> Any:\n",
    "        \"\"\"gibt den Inhalt des Knotens an der Stelle index zurück\"\"\"\n",
    "        if self.erster is None:\n",
    "            return None\n",
    "        knoten = self.erster\n",
    "        for i in range(index):\n",
    "            if knoten.naechster is None:\n",
    "                return None\n",
    "            knoten = knoten.naechster\n",
    "        return knoten.inhalt\n",
    "    \n",
    "    def ersetzen(self, index: int, neuer_inhalt: Any) -> None:\n",
    "        \"\"\"ersetzt den Inhalt des Knotens an der Stelle index durch neuer_inhalt\"\"\"\n",
    "        if self.erster is None:\n",
    "            return None\n",
    "        knoten: Knoten = self.erster \n",
    "        for i in range(index):\n",
    "            if knoten.naechster is None:\n",
    "                return\n",
    "            knoten = knoten.naechster\n",
    "        knoten.inhalt = neuer_inhalt\n",
    "\n",
    "    def enthaelt(self, inhalt: Any) -> bool:\n",
    "        \"\"\"gibt True zurück, wenn inhalt in der Liste enthalten ist, sonst False\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "    \n",
    "    def anhaengen(self, inhalt: Any) -> None:\n",
    "        \"\"\"hängt einen neuen Knoten mit dem Inhalt inhalt ans Ende der Liste an\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "           \n",
    "    def entfernen_vorne(self) -> Any:\n",
    "        \"\"\"entfernt den ersten Knoten und gibt dessen Inhalt zurück\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "    def entfernen(self, index: int) -> Any:\n",
    "        \"\"\"entfernt den Knoten an der Stelle index und gibt dessen Inhalt zurück\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "    def einfuegen(self, index: int, inhalt: Any) -> None:\n",
    "        \"\"\"fügt einen neuen Knoten mit inhalt an der Stelle index ein\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "    def entfernen_inhalt(self, inhalt: Any) -> None:\n",
    "        \"\"\"entfernt alle Knoten mit dem Inhalt inhalt\"\"\"\n",
    "        ...  # Hier Lösung ergänzen\n",
    "\n",
    "\n",
    "# Mit den folgenden Tests kannst du deine Implementierung überprüfen.\n",
    "# Führe einfach diese Zelle aus, um die Tests zu starten.\n",
    "\n",
    "test = TestsVerketteteListe(VerketteteListe)\n",
    "reihenfolge = [\"enthaelt\", \"anhaengen\", \"entfernen_vorne\", \"entfernen\", \"einfuegen\", \"entfernen_inhalt\"]\n",
    "test.fuehre_tests_aus(reihenfolge)"
   ]
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "base",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.11.8"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
